KPanelApplet Class Reference

`#include <kpanelapplet.h>`

Inherits QFrame.

## Public Types

enum | Type { Normal = 0, Stretch }
enum | Action { About = 1, Help = 2, Preferences = 4, ReportBug = 8 }
enum | Position { pLeft = 0, pRight, pTop, pBottom }
enum | Alignment { LeftTop = 0, Center, RightBottom }
enum | Direction { Up = 0, Down, Left, Right }

## Signals

void | updateLayout ()
void | requestFocus ()
void | requestFocus (bool focus)

## Public Member Functions

| KPanelApplet (const QString &configFile, Type t=Normal, int actions=0, QWidget *parent=0, const char *name=0, WFlags f=0)
| ~KPanelApplet ()
virtual int | widthForHeight (int height) const
virtual int | heightForWidth (int width) const
KConfig * | config () const
KSharedConfig::Ptr | sharedConfig () const
Type | type () const
int | actions () const
virtual void | action (Action a)
const QPopupMenu * | customMenu () const
void | setPosition (Position p)
void | setAlignment (Alignment a)

## Protected Member Functions

virtual void | about ()
virtual void | help ()
virtual void | preferences ()
virtual void | reportBug ()
Orientation | orientation () const
Position | position () const
Alignment | alignment () const
virtual void | positionChange (Position p)
virtual void | alignmentChange (Alignment)
void | setCustomMenu (const QPopupMenu *)
void | watchForFocus (QWidget *widget, bool watch=true)
void | needsFocus (bool focus)
virtual KDE_DEPRECATED void | orientationChange (Orientation)
Direction | popupDirection ()
virtual KDE_DEPRECATED void | popupDirectionChange (Direction)
bool | eventFilter (QObject *, QEvent *)
virtual void | virtual_hook (int id, void *data)

## Protected Attributes

KPanelAppletPrivate * | d

## Detailed Description

KDE Panel Applet class

Panel applets

- Are small applications living in the KDE panel.
- Are implemented as DSOs (Dynamic Shared Objects).

Note: For security and stability reasons the panel won't load untrusted third party applets directly into its namespace but via an external wrapper process.

The panel locates available applets by searching for applet desktop files in (ALL_DIRS)/share/apps/kicker/applets. Every panel applet should install a desktop file there to be recognized by the panel.

Besides standard keys like "Name", "Comment" and "Icon" there are two panel applet specific keys:

X-KDE-Library
Used by the panel to locate the applet DSO (Dynamic Shared Object) Example: X-KDE-Library=libexampleapplet

X-KDE-UniqueApplet
Similar to KApplication and KUniqueApplication there are two types of panel applets. Use unique applets when it makes no sence to run more than one instance of a applet in the panel. A good example for unique applets is the taskbar applet. Use normal applets when you need instance specific configuration. An example is the koolclock applet where you might want to run two instances in your panel, one configured as analog clock, the other one as digital clock. X-KDE-UniqueApplet is a boolean key which defaults to "false". Example: X-KDE-UniqueApplet=true

Back to panel applet DSOs, the following conventions are used for KDE: Name: lib<appletname>applet.la LDFLAGS: -module -no-undefined

To implement a panel applet it is not enough to write a class inheriting from KPanelApplet but you also have to provide a factory function in your DSO. A sample factory function could look like this:

extern "C"
{
KPanelApplet* init(QWidget *parent, const QString& configFile)
{
KGlobal::locale()->insertCatalogue("exampleapplet");
return new ExampleApplet(configFile, KPanelApplet::Normal,
KPanelApplet::About | KPanelApplet::Help | KPanelApplet::Preferences,
parent, "exampleapplet");
}
}

Note: Don't change the factory function signature or the panel will fail to load your applet.

Author
  Matthias Elter elter.nosp@m.@kde.nosp@m..org

Definition at line 97 of file kpanelapplet.h.

## Member Enumeration Documentation

enum KPanelApplet::Action

This enum holds flags which can be ORed together to describe which items the context menu over the applet handle contains.

Definition at line 112 of file kpanelapplet.h.

enum KPanelApplet::Type

This enum describes the type of the applet.

Definition at line 106 of file kpanelapplet.h.

## Constructor & Destructor Documentation

KPanelApplet::KPanelApplet | ( | const QString & | configFile,
|  | Type | t = `Normal`,
|  | int | actions = `0`,
|  | QWidget * | parent = `0`,
|  | const char * | name = `0`,
|  | WFlags | f = `0`
| ) |  |

Constructs a KPanelApplet just like any other widget.

Parameters

  configFile | The configFile handed over in the factory function.
  t | The applet type().
  actions | Standard RMB menu actions supported by the applet (see action() ).
  parent | The pointer to the parent widget handed over in the factory function.
  name | A Qt object name for your applet.
  f | Window control flags

Definition at line 45 of file kpanelapplet.cpp.

KPanelApplet::~KPanelApplet | ( |  | ) |

Destructor.

Definition at line 67 of file kpanelapplet.cpp.

## Member Function Documentation

virtual void KPanelApplet::about | ( |  | ) |

inline protected virtual

Is called when the user selects "About" from the applet's RMB menu.

Reimplement this function to launch a about dialog.

Note that this is called only when your applet supports the About action. See Action and KPanelApplet().

Definition at line 272 of file kpanelapplet.h.

void KPanelApplet::action | ( | Action | a | ) |

virtual

Generic action dispatcher.

Called when the user selects an item from the applet's RMB menu.

Reimplement this function to handle actions.

For About, Help, Preferences and ReportBug, use the convenience handlers ref about(), help(), preferences(), reportBug()

Definition at line 118 of file kpanelapplet.cpp.

int KPanelApplet::actions | ( |  | ) | const

inline

Returns
  int indicating the supported RMB menu actions. Action

Definition at line 200 of file kpanelapplet.h.

Alignment KPanelApplet::alignment | ( |  | ) | const

inline protected

Returns
  the applet's alignment. (top/left, center, or bottom/right)

Definition at line 313 of file kpanelapplet.h.

virtual void KPanelApplet::alignmentChange | ( | Alignment |  | ) |

inline protected virtual

The panel on which this applet resides has changed its alignment.

Reimplement this change handler in order to adjust the look of your applet.

Definition at line 327 of file kpanelapplet.h.

KConfig* KPanelApplet::config | ( |  | ) | const

inline

Always use this KConfig object to save/load your applet's configuration.

For unique applets this config object will write to a config file called <appletname>rc in the user's local KDE directory.

For normal applets this config object will write to a instance specific config file called <appletname><instanceid>rc in the user's local KDE directory.

Definition at line 187 of file kpanelapplet.h.

const QPopupMenu * KPanelApplet::customMenu | ( |  | ) | const

Returns
  the applet's custom menu, usually the same as the context menu, or 0 if none see setCustomMenu(QPopupMenu*)

Definition at line 130 of file kpanelapplet.cpp.

virtual int KPanelApplet::heightForWidth | ( | int | width | ) | const

inline virtual

Returns
  A suggested height for a given width.

Every applet should reimplement this function.

Depending on the panel orientation the height (horizontal panel) or the width (vertical panel) of the applets is fixed. The exact values of the fixed size component depend on the panel size.

On a vertical panel the applet width is fixed, the panel will call heightForWidth(int width) with `width` equal to 'the fixed applet width' when laying out the applets.

The applet can now choose the other size component (height) based on the given width.

The height you return is granted.

Definition at line 176 of file kpanelapplet.h.

virtual void KPanelApplet::help | ( |  | ) |

inline protected virtual

Is called when the user selects "Help" from the applet's RMB menu.

Reimplement this function to launch a manual or help page.

Note that this is called only when your applet supports the Help action. See Action and KPanelApplet().

Definition at line 281 of file kpanelapplet.h.

void KPanelApplet::needsFocus | ( | bool | focus | ) |

protected

Call this whenever focus is needed or not needed.

You do not have to call this method for widgets that have been registered with watchForFocus

Parameters

  focus | whether to or not to request focus

Since
  3.4

Definition at line 162 of file kpanelapplet.cpp.

Qt::Orientation KPanelApplet::orientation | ( |  | ) | const

protected

Returns
  the applet's orientation. (horizontal or vertical)

Definition at line 97 of file kpanelapplet.cpp.

virtual KDE_DEPRECATED void KPanelApplet::orientationChange | ( | Orientation |  | ) |

inline protected virtual

The orientation changed to `orientation`.

Reimplement this change handler in order to adjust the look of your applet.

Deprecated:
  Reimplement positionChange instead.

Definition at line 364 of file kpanelapplet.h.

KPanelApplet::Direction KPanelApplet::popupDirection | ( |  | ) |

protected

A convenience method that translates the position of the applet into which direction to show a popup.

Definition at line 107 of file kpanelapplet.cpp.

virtual KDE_DEPRECATED void KPanelApplet::popupDirectionChange | ( | Direction |  | ) |

inline protected virtual

The popup direction changed to `direction`.

Reimplement this change handler in order to adjust the look of your applet.

Deprecated:
  Reimplement positionChange instead.

Definition at line 379 of file kpanelapplet.h.

Position KPanelApplet::position | ( |  | ) | const

inline protected

Returns
  the applet's position. (top, left, bottom, or right)

Definition at line 309 of file kpanelapplet.h.

void KPanelApplet::positionChange | ( | Position | p | ) |

protected virtual

The panel on which this applet resides has changed its position.

Reimplement this change handler in order to adjust the look of your applet.

Definition at line 89 of file kpanelapplet.cpp.

virtual void KPanelApplet::preferences | ( |  | ) |

inline protected virtual

Is called when the user selects "Preferences" from the applet's RMB menu.

Reimplement this function to launch a preferences dialog or kcontrol module.

Note that this is called only when your applet supports the preferences action. See Action and KPanelApplet().

Definition at line 290 of file kpanelapplet.h.

virtual void KPanelApplet::reportBug | ( |  | ) |

inline protected virtual

Is called when the user selects "Report bug" from the applet's RMB menu.

Reimplement this function to launch a bug reporting dialog.

Note that this is called only when your applet supports the ReportBug action. See Action and KPanelApplet()

Definition at line 300 of file kpanelapplet.h.

void KPanelApplet::requestFocus | ( |  | ) |

signal

Request keyboard focus from the panel.

Deprecated:

void KPanelApplet::requestFocus | ( | bool | focus | ) |

signal

Request keyboard focus from the panel.

Applets should never call this directly but rather call needsFocus(bool)

See also
  needsFocus

Parameters

  focus | activate the window and ensure the panel remains visible when true Each and ever time a requestFocus(true) is emitted, it MUST be paired eventually with a requestFocus(false) otherwise the panel may end up never hiding

Since
  3.4

void KPanelApplet::setAlignment | ( | Alignment | a | ) |

Definition at line 81 of file kpanelapplet.cpp.

void KPanelApplet::setCustomMenu | ( | const QPopupMenu * | menu | ) |

protected

Use this method to set the custom menu for this applet so that it can be shown in the applet handle menu and other appropriate places that the applet many not itself be aware of.

The applet itself is still responsible for deleting and managing the the menu.

If the menu is deleted during the life of the applet, be sure to call this method again with the new menu (or 0) to avoid crashes

Definition at line 135 of file kpanelapplet.cpp.

void KPanelApplet::setPosition | ( | Position | p | ) |

Definition at line 74 of file kpanelapplet.cpp.

Type KPanelApplet::type | ( |  | ) | const

inline

Returns
  Type indicating the applet's type. Type

Definition at line 194 of file kpanelapplet.h.

void KPanelApplet::updateLayout | ( |  | ) |

signal

Emit this signal to make the panel relayout all applets, when you want to change your width (horizontal panel) or height (vertical panel).

The panel is going to relayout all applets based on their widthForHeight(int height) (horizontal panel) or heightForWidth(int width) (vertical panel).

Please note that the panel may change the applet's location if the new widthForHeight(int height) (horizontal panel) or heightForWidth(int width) (vertical panel) does not fit into the current panel layout.

void KPanelApplet::watchForFocus | ( | QWidget * | widget,
|  | bool | watch = `true`
| ) |  |

protected

Register widgets that can receive keyboard focus with this this method This call results in an eventFilter being places on the widget.

Parameters

  widget | the widget to watch for keyboard focus
  watch | whether to start watching the widget, or to stop doing so

Since
  3.4

Definition at line 140 of file kpanelapplet.cpp.

virtual int KPanelApplet::widthForHeight | ( | int | height | ) | const

inline virtual

Returns a suggested width for a given height.

Every applet should reimplement this function.

Depending on the panel orientation the height (horizontal panel) or the width (vertical panel) of the applets is fixed. The exact values of the fixed size component depend on the panel size.

On a horizontal panel the applet height is fixed, the panel will call widthForHeight(int height) with `height` equal to 'the fixed applet height' when laying out the applets.

The applet can now choose the other size component (width) based on the given height.

The width you return is granted.

Definition at line 155 of file kpanelapplet.h.

The documentation for this class was generated from the following files:

- kpanelapplet.h
- kpanelapplet.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys